; $Id: dcs_save_scattering.pro,v 1.8 2002/07/13 20:30:59 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_save_scattering_strategy_handler,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=pstate,/no_copy
nfiles=(*pstate).nfiles
temps=(*pstate).temps
;
save_params=*(*pstate).ptr
temperatures=*(*pstate).ptr_temps
;
evid=event.id

if (evid eq (*pstate).done) then begin
	widget_control,event.top,/destroy
	return
endif
;
if (evid eq (*pstate).cancel) then begin
	save_params[3]="Cancel"
	*(*pstate).ptr=save_params
	widget_control,event.top,set_uvalue=pstate,/no_copy
	widget_control,event.top,/destroy
	return
endif
;
widget_type=widget_info(evid,/type)
;
; widget_type=1 for a button widget.
if (widget_type eq 1) then begin
	evsel=event.select
	if (evsel eq 1) then begin
		case evid of
			(*pstate).dodt: save_params[0]="DODT"
			(*pstate).dode: save_params[0]="DODE"
			(*pstate).sqom: save_params[0]="SQOM"
			(*pstate).ssqw: save_params[0]="SSQW"
			(*pstate).kiqw: save_params[0]="KIQW"
			(*pstate).gdos: save_params[0]="GDOS"
			(*pstate).save_dave: save_params[1]="SAVE_DAVE"
			(*pstate).octaveasc: save_params[1]="OCTAVEASC"
			(*pstate).octavebin: save_params[1]="OCTAVEBIN"
			(*pstate).idlformat: save_params[1]="IDLFORMAT"
			(*pstate).treatform: save_params[1]="TREATFORM"
			(*pstate).drotate: result=dialog_message([$
				"Time channel rotation procedures",$
				"are not yet implemented."])
			(*pstate).detefen: result=dialog_message([$
				"Energy-dependent detector efficiency",$
				"corrections are not yet implemented."])
			(*pstate).specops: begin
				operation="unknown"
				dcs_davePtr_ops,operation=operation,$
					davePtr=(*pstate).davePtr,$
					base=event.top,$
					message_str=(*pstate).message_str
				*(*pstate).ptr_operation=operation
			end
			(*pstate).compress: save_params[2]="COMPRESS"
			else:
		endcase
		case evid of
			(*pstate).dodt: widget_control,(*pstate).tempvals,sensitive=0
			(*pstate).dode: widget_control,(*pstate).tempvals,sensitive=0
			(*pstate).sqom: widget_control,(*pstate).tempvals,sensitive=0
			(*pstate).ssqw: widget_control,(*pstate).tempvals,sensitive=1
			(*pstate).kiqw: widget_control,(*pstate).tempvals,sensitive=1
			(*pstate).gdos: widget_control,(*pstate).tempvals,sensitive=1
			else:
		endcase
	endif
	if (evsel eq 2) then begin
		if (evid eq (*pstate).compress) then save_params[2]="NOCOMPRESS"
	endif
endif
;
for k=0,nfiles-1 do begin
	if (evid eq (*pstate).temps[k]) then begin
		if (event.type eq 0) then widget_control,evid,get_value=temperat
		temperatures[k]="T = "+$
			string(stregex(temperat,'[0-9.]+',/extract),format='(f7.2)')+"K"
		widget_control,evid,set_value=temperatures[k]
	endif
endfor
;
*(*pstate).ptr=save_params
*(*pstate).ptr_temps=temperatures
widget_control,event.top,set_uvalue=pstate,/no_copy
;
end


;************************************************************************************************
pro dcs_save_scattering_strategy,dcs_base,save_params,float_temperatures,$
	ktemperatures,etfirst,etlast,davePtr=davePtr,operation=operation,$
	message_str=message_str
;************************************************************************************************
;
compile_opt strictarr
;
nfiles=n_elements(float_temperatures)
sams=intarr(nfiles)
temps=intarr(nfiles)
temperatures=string(float_temperatures,format='(f7.2)')
;
tlb=widget_base(title='Save Strategy',/row,group_leader=dcs_base,/modal)
	leftcol=widget_base(tlb,/col)
		inchoice=widget_base(leftcol,/col,/exclusive,/frame)
			dodt=widget_button(inchoice,value="Save as ''d2sigma/dOmegadt''")
			dodE=widget_button(inchoice,value="Save as ''d2sigma/dOmegadEf''")
			sqom=widget_button(inchoice,value="Save as ''S(Q,omega)''")
			ssqw=widget_button(inchoice,value="Save as ''Symmetrized S(Q,omega)''")
			kiqw=widget_button(inchoice,value="Save as ''Chi'"+"'(Q,omega)''")
			gdos=widget_button(inchoice,value="Save as ''g(omega)''")
		outchoice=widget_base(leftcol,/col,/exclusive,/frame)
			save_dave=widget_button(outchoice,value="Save in DAVE format")
			octaveasc=widget_button(outchoice,value="Save in Octave ascii format")
			octavebin=widget_button(outchoice,value="Save in Octave binary format")
;			idlformat=widget_button(outchoice,value="Save in internal IDL format")
;			treatform=widget_button(outchoice,value="Save in TREAT output format")
		compchoice=widget_base(leftcol,/col,/nonexclusive,/frame)
			compress=widget_button(compchoice,value="Compress the output data?")
	midcol=widget_base(tlb,/col)
		upsec=widget_base(midcol,/col,/frame)
			start=widget_text(upsec,value=string(etfirst,format='(f8.2)')+" meV")
			stop=widget_text(upsec,value=string(etlast,format='(f8.2)')+" meV")
		midsec=widget_base(midcol,/col,/frame)
			samtemptit1=widget_label(midsec,value="Sample temperatures")
			samtemptit2=widget_label(midsec,value="(needed to compute")
			samtemptit3=widget_label(midsec,value="detailed balance factors)")
			samtemp=widget_base(midsec,/row)
				samvals=widget_base(samtemp,/col)
					for k=0,nfiles-1 do $
						sams[k]=widget_text(samvals,xsize=8,value="Series"+strcompress(k+1,/remove)+":")
				tempvals=widget_base(samtemp,/col,sensitive=0)
					for k=0,nfiles-1 do $
						temps[k]=widget_text(tempvals,xsize=11,$
							value="T ="+strcompress(temperatures[k])+"K",/editable)
;		midchoice1=widget_base(upsec,/col,/nonexclusive)
;			drotate=widget_button(midchoice1,value="Rotate input data?")
;		channels=widget_base(upsec,/row)
;			nchannels=widget_text(channels,xsize=5,value=string(0,format='(i4)'),$
;				sensitive=0,/editable)
;			tchannels=widget_label(channels,value=" channels")
;		detefenchoice=widget_base(midcol,/col,/nonexclusive,/frame)
;			detefen=widget_button(detefenchoice,$
;				value="Correct for energy-dependent detector efficiency?")
;		specialops=widget_base(midcol,/col,/nonexclusive,/frame)
;			specops=widget_button(specialops,value="Special operations?")
		done=widget_button(midcol,value="Proceed")
		cancel=widget_button(midcol,value="Cancel")
;
dave_position_tlb,tlb
widget_control,tlb,/realize
;
widget_control,sqom,set_button=1
widget_control,save_dave,set_button=1

save_params=["SQOM","SAVE_DAVE","NOCOMPRESS","Proceed"]
ptr=ptr_new(save_params)
ptr_temps=ptr_new(temperatures)
ptr_operation=ptr_new("")
;
state={$
	dodt:dodt,$
	dode:dode,$
	sqom:sqom,$
	ssqw:ssqw,$
	kiqw:kiqw,$
	gdos:gdos,$
	temps:temps,$
	done:done,$
	cancel:cancel,$
	ptr:ptr,$
	ptr_temps:ptr_temps,$
	drotate:-1,$;drotate,$
	nfiles:nfiles,$
	save_dave:save_dave,$
	octaveasc:octaveasc,$
	octavebin:octavebin,$
	idlformat:-1,$;idlformat,$
	treatform:-1,$;treatform,$
	compress:compress,$
	detefen:-1,$;detefen,$
	specops:-1,$;specops,$
	tempvals:tempvals,$
	ptr_operation:ptr_operation,$
	davePtr:davePtr,$
	message_str:message_str}
;
pstate=ptr_new(state)
widget_control,tlb,set_uvalue=pstate,/no_copy
;
xmanager,'dcs_save_scattering_strategy',tlb,$
	event_handler='dcs_save_scattering_strategy_handler'
;
save_params=*ptr
ptr_free,ptr
temperatures=*ptr_temps
ptr_free,ptr_temps
operation=*ptr_operation
ptr_free,ptr_operation
;
; Values of kT in meV.
ktemperatures=float(stregex(temperatures,'[0-9.]+',/extract))*!dcs_boltzmann/!dcs_meVcon
;
end


;************************************************************************************************
pro dcs_save_scattering,dcs_base,samfiles,temperatures,logentry=logentry,message_str=message_str
;************************************************************************************************
;
compile_opt strictarr
;
restore,filename=samfiles[0]
;
ngtchan0=(*(*(*davePtr).dataStrPtr).specificPtr).ngtchan0
times=(*(*(*(*davePtr).dataStrPtr).specificPtr).time_propsPtr)[0:ngtchan0]
tstart=times[0:ngtchan0-1]
tstop=times[1:ngtchan0]
;
e0=!dcs_hsq2mn/(*(*(*davePtr).dataStrPtr).specificPtr).ch_wl^2
energies=(*(*(*(*davePtr).dataStrPtr).specificPtr).energy_propsPtr)[0:ngtchan0]
etstart=energies[0:ngtchan0-1]
etstop=energies[1:ngtchan0]
;
dcs_save_scattering_strategy,dcs_base,save_params,temperatures,ktemperatures,$
	etstart[0],etstop[ngtchan0-1],davePtr=davePtr,operation=operation,$
	message_str=message_str
;
if (save_params[3] eq "Cancel") then return
;
; Mean times of flight from sample to detector
tmean=0.5*(tstart+tstop)
;
; Mean energy transfers
etmean=0.5*(etstart+etstop)
;
; Reciprocal time channel widths
twid_inv=1.0/(tstop-tstart)
;
; Mean scattering angles and elastic Q values
angle_props=*(*(*(*davePtr).dataStrPtr).specificPtr).angle_propsPtr
Q_props=*(*(*(*davePtr).dataStrPtr).specificPtr).Q_propsPtr
tthmean=angle_props[*,0]
qelmean=Q_props[*,0]
ntth=n_elements(tthmean)
;
; Values of 2*cos(2theta)
twocostth=2.0*cos(tthmean*!dtor)
;
ef=e0-etmean
root=sqrt(e0*ef)
;
; Ratios (k_i/k_f)
kikfratio=root/ef
;
unitvectth=fltarr(ntth)+1
;
; Create 2-d array of inelastic Q values
; Next line creates matrices with dimensions [ngtchan0,ntth].
hsqqsq=dcs_operate((e0+ef)#unitvectth,root#twocostth,"-")
conversion=2*!pi/sqrt(!dcs_hsq2mn)
qinel=sqrt(hsqqsq)*conversion
;
compressed=save_params[2] eq "COMPRESS"
;
out_dataPtr=ptr_new({description:save_params,tmean:tmean,etmean:etmean,$
	tthmean:tthmean,qelmean:qelmean,qinel:qinel,$
	qty:fltarr(ngtchan0,ntth),err:fltarr(ngtchan0,ntth)})
;
n_samfiles=n_elements(samfiles)
;
lines=strarr(2*n_samfiles+5)
lines[0:1]=["Please wait while the calculations proceed.",$
						"---------------------------------------------"]
bases=intarr(2*n_samfiles)
;
for k=0,n_samfiles-1 do begin
	filename=samfiles[k]
	lines[k*2+3]="Reading input file "+filename
	dcs_message_display,lines,base,group_leader=dcs_base,alignment=0
	bases[k*2]=base
	free_all_ptrs,davePtr
	restore,filename=filename
;
; Values of exp(-E/2kT)
	dbal=exp(-etmean/(2.0*ktemperatures[k]))
;
; Lines containing matrix multiplication (#) create matrices with
; dimensions [ngtchan0,ntth].
	case save_params[0] of
	  "DODT": factor=twid_inv#unitvectth
	  "DODE": factor=(twid_inv*kikfratio^3)#unitvectth
	  "SQOM": factor=(twid_inv*kikfratio^4)#unitvectth
	  "SSQW": factor=(twid_inv*kikfratio^4*dbal)#unitvectth
	  "KIQW": factor=(twid_inv*kikfratio^4*(1-dbal^2))#unitvectth
	  "GDOS": factor=((twid_inv*kikfratio^4*(1-dbal^2)*etmean)#unitvectth)/hsqqsq
	  else: if (!debug) then print,"Error in dcs_save_scattering: STOP"
	endcase
;
	case save_params[0] of
	  "DODT": what="d2sigma/dOmegadt"
	  "DODE": what="d2sigma/dOmegadE"
	  "SQOM": what="S(Q,omega)"
	  "SSQW": what="''Symmetrized'' S(Q,omega)"
	  "KIQW": what="Chi'"+"'(Q,omega)"
	  "GDOS": what="g(omega)"
	  else:
	endcase
;
	(*out_dataPtr).qty=factor * $
		(*(*(*davePtr).dataStrPtr).commonStr.histPtr).qty
	(*out_dataPtr).err=factor * $
		(*(*(*davePtr).dataStrPtr).commonStr.histPtr).err
;
	logentry=logentry+string(10B)+"Sample run number"+strcompress(k+1)+":"
;
	case save_params[1] of
		"SAVE_DAVE": ext=".dave"
		"OCTAVEASC": ext=".ASC"
		"OCTAVEBIN": ext=".BIN"
		"IDLFORMAT": ext=".IDL"
		"TREATFORM": ext=".TRE"
	endcase
	newfilename=strmid(filename,0,strlen(filename)-8)+save_params[0]+ext
	if (compressed) then newfilename=newfilename+".gz"
;
	lines[k*2+4]="Writing output file "+newfilename
	dcs_message_display,lines,base,group_leader=dcs_base,alignment=0
	bases[k*2+1]=base
	logentry=logentry+string(10B)+$
		what+" is to be written to file "+newfilename+"."
;
	case save_params[1] of
		"SAVE_DAVE": begin
			(*(*(*davePtr).dataStrPtr).commonStr.histPtr).qty=(*out_dataPtr).qty
			(*(*(*davePtr).dataStrPtr).commonStr.histPtr).err=(*out_dataPtr).err
			if (save_params[0] ne "DODT") then begin
				(*(*(*davePtr).dataStrPtr).commonStr.histPtr).x=energies
				(*(*davePtr).dataStrPtr).commonStr.xunits="energy:meV"
				(*(*davePtr).dataStrPtr).commonStr.xlabel="Energy transfer"
				(*(*davePtr).dataStrPtr).commonStr.histlabel=what
			endif
			if (operation eq "ytoQofE") then begin
				dcs_davePtr_ops,davePtr=davePtr,operation=operation,base=dcs_base
				logentry=logentry+string(10B)+$
				"Transforming Q to Q(E) along k0."
			endif
			if (operation eq "ytoQcompofE") then begin
				dcs_davePtr_ops,davePtr=davePtr,operation=operation,base=dcs_base
				logentry=logentry+string(10B)+$
				"Transforming Q to Q component along k0."
			endif
			(*(*(*davePtr).dataStrPtr).commonStr.treatmentPtr)=strsplit(logentry,string(10B),/extract)
			save,davePtr,filename=newfilename
		end
		"OCTAVEASC": dcs_write_asciiOctavefile,$
			newfilename,datafile=*out_dataPtr,compress=compressed
		"OCTAVEBIN": dcs_write_binaryOctavefile,$
			newfilename,datafile=*out_dataPtr,compress=compressed
		"IDLFORMAT":	save,filename=newfilename,*out_dataPtr,compress=compressed
		"TREATFORM": begin
			openw,lun,newfilename,/get_lun,compress=compressed
			for ich=0,ngtchan0-1 do begin
				printf,lun,etmean[ich],ntth
				for ig=0,ntth-1 do printf,lun,qinel[ich,ig],$
					(*out_dataPtr).qty[ich,ig],(*out_dataPtr).err[ich,ig]
			endfor
			free_lun,lun
		end
	endcase
;
endfor
;
wait,3
for k=2*n_samfiles-1,0,-1 do widget_control,bases[k],/destroy
;
ptr_free,out_dataPtr
;
free_all_ptrs,davePtr
;
end