; $Id: dcs_message_display.pro,v 1.3 2002/07/13 20:14:57 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_message_display,lines,base,group_leader=group_leader,alignment=alignment
;************************************************************************************************
; This routine writes a message to the screen. It assumes there is already a top level base and it
; returns the ID of the message widget. Justification is determined by the keyword "alignment".
;
compile_opt strictarr
;
if (not keyword_set(alignment)) then alignment=0
;
nlines=n_elements(lines)
;
; Create the widget.
base=widget_base(title=' ',/col,group_leader=group_leader,/modal)
case alignment of
	-1: top=widget_label(base,value=lines[0],/align_left)
	 0: top=widget_label(base,value=lines[0],/align_center)
	 1: top=widget_label(base,value=lines[0],/align_right)
	else:
endcase
if (nlines gt 1) then begin
	mid=intarr(nlines)
	for i=1,nlines-1 do begin
		case alignment of
			-1: mid[i]=widget_label(base,value=lines[i],/align_left)
			 0: mid[i]=widget_label(base,value=lines[i],/align_center)
			 1: mid[i]=widget_label(base,value=lines[i],/align_right)
			else:
		endcase
	endfor
endif
bot=widget_base(title=' ',base,/row,/align_center)
;
; Realize the widget.
dave_position_tlb,base
widget_control,base,/realize
;
end
