; $Id: dcstoolsperformance.pro,v 1.5 2002/07/13 20:14:58 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro DCSToolsPerformance_handler,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=state
done=state.done
if (event.id eq done) then begin
	widget_control,event.top,/destroy
	return
endif
end


;************************************************************************************************
pro DCSToolsPerformance_mouseposition,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=state
messagetext=state.messagetext
; Respond to cursor.
;
; Convert cursor device coordinates to data coordinates.
x=CONVERT_COORD(event.x,event.y,/device,/to_data)
;
wl=x[0]
if (wl ge state.wlmin and wl le state.wlmax) then begin
	flux1=dcs_jcc_flux(wl,1)
	flux2=dcs_jcc_flux(wl,2)
	flux3=dcs_jcc_flux(wl,3)
	mspeed=20000
	resn1=dcs_jcc_resn(wl,wl,1,mspeed)
	resn2=dcs_jcc_resn(wl,wl,2,mspeed)
	resn3=dcs_jcc_resn(wl,wl,3,mspeed)
	value=[string(wl,format='("Wavelength:",(f8.3))'),$
		"Low resolution mode (mode 1):",$
		string(flux1,format='(10x,"Flux:",(f8.0))'),$
		string(resn1,format='(10x,"Resolution:",(f8.1))'),$
		"Medium resolution mode (mode 2):",$
		string(flux2,format='(10x,"Flux:",(f8.0))'),$
		string(resn2,format='(10x,"Resolution:",(f8.1))'),$
		"High resolution mode (mode 3):",$
		string(flux3,format='(10x,"Flux:",(f8.0))'),$
		string(resn3,format='(10x,"Resolution:",(f8.1))')]
	widget_control,messagetext,set_value=value
endif
;
end


;************************************************************************************************
pro DCSToolsPerformance,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue = davePtr,/no_copy
;
dcs_sysvars,davePtr=davePtr
;
tvlct,r,g,b,/get
rgbptr=ptr_new({r:r,g:g,b:b})
;
screensize=!screensize
;
xsz=screensize[0]
ysz=screensize[1]
tlb=widget_base(title='Flux and Resolution at 20000 rpm',/row,$
	group_leader=event.top,/modal)
plots=widget_base(tlb,/col)
fluxplot=widget_draw(plots,xsize=0.5*xsz,ysize=0.42*ysz,$
			/button_events,/motion_events,event_pro='DCSToolsPerformance_mouseposition')
resnplot=widget_draw(plots,xsize=0.5*xsz,ysize=0.42*ysz,$
			/button_events,/motion_events,event_pro='DCSToolsPerformance_mouseposition')
; Realize the widget
otherstuff=widget_base(tlb,/col)
done=widget_button(otherstuff,value='Done')
messagetext=widget_text(otherstuff,ysize=10,xsize=30,$
	value=strarr(20))
;
centertlb,tlb
widget_control,tlb,/realize
;
wlmin=1.0
wlmax=12.0
;
state={done:done,messagetext:messagetext,wlmin:wlmin,wlmax:wlmax}
widget_control,tlb,set_uvalue=state
;
dwl=0.1
nwl=(wlmax-wlmin)/dwl+1
xlim=[0,12]
wl=wlmin+findgen(nwl)*dwl
xlim=[0,wlmax]
;
widget_control,fluxplot,get_value=winid
wset,winid

minflux=min(dcs_jcc_flux(wl,1))*0.1
maxflux=max(dcs_jcc_flux(wl,1))
ylim=[minflux,maxflux]

; Save current color table.
oldct=dcs_getctinfo()
; Use Alan's routine to load 256 colors.
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue

; Plot the frame.
plot,xlim,ylim,xtitle='Wavelength (A)',ytitle='Flux at sample (n/cm2/s)',thick=2.0,$
	/nodata,/ynozero,/ylog,background=0,color=1

for rmode=1,3 do begin
	flux=dcs_jcc_flux(wl,rmode)
	oplot,wl,flux,color=rmode,thick=2.0
endfor
;
widget_control,resnplot,get_value=winid
wset,winid
;
mspeed=20000
wli=wl
wlf=wl
minresn=min(dcs_jcc_resn(wl,wl,1,mspeed))*0.1
maxresn=max(dcs_jcc_resn(wl,wl,1,mspeed))
ylim=[minresn,maxresn]
; Plot the frame.
plot,xlim,ylim,xtitle='Wavelength (A)',ytitle='Resolution FWHM (ueV)',thick=2.0,$
	/nodata,/ynozero,/ylog,background=0,color=1
;
for rmode=1,3 do begin
	resn=dcs_jcc_resn(wl,wl,rmode,mspeed)
	oplot,wl,resn,color=rmode,thick=2.0
endfor
;
; Revert to color table in existence at start of procedure.
tvlct,oldct
;
xmanager,'DCSToolsPerformance',tlb,event_handler='DCSToolsPerformance_handler',$
	/no_block,group_leader=group_leader
;
dave_makeDavePtr,davePtr=davePtr
;
widget_control,event.top,set_uvalue = davePtr,/no_copy
;
tvlct,(*rgbptr).r,(*rgbptr).g,(*rgbptr).b
ptr_free,rgbptr
;
end
