; $Id: fans_settings.pro,v 1.4 2002/07/16 16:09:31 azuah Exp $
;===============================================================================
; Event Handler for FANS_DATREDUC program defined in fans_datreduc.pro.
; Modifies the options for handling multiple input files. Can choose
; between summing, merging or separate when multiple input files are
; specified.
;
; Richard Tumanjong Azuah
;
; June 7 2002 - Initial writing
; 
;===============================================================================



;===============================================================================
pro fans_settings_event, event

;print,'Dummy handler called...'

;help, event,/structure

widget_control, event.top, get_uvalue=sPtr


sname = tag_names(event,/structure_name)
if (sname eq 'WIDGET_DROPLIST') then begin
    (*sPtr).index = event.index
    return
endif

ename = widget_info(event.id,/uname)

if (event.select eq 0) then begin ; ==> a radio button is being released
    case ename of               ; need to know when switching from 'separate'
        'ssep': (*sPtr).stype = 1
        'bsep': (*sPtr).stype = 2
        'fsep': (*sPtr).stype = 3
        else: return 
    endcase 
    return
endif

; If reach here ==> radio button is being set
case ename of

    'ssum': (*(*sPtr).mfoPtr)[0] = 0
    'sapd': (*(*sPtr).mfoPtr)[0] = 1
    'ssep': (*(*sPtr).mfoPtr)[0] = 2
    
    'bsum': (*(*sPtr).mfoPtr)[1] = 0
    'bapd': (*(*sPtr).mfoPtr)[1] = 1
    'bsep': (*(*sPtr).mfoPtr)[1] = 2

    'fsum': (*(*sPtr).mfoPtr)[2] = 0
    'fapd': (*(*sPtr).mfoPtr)[2] = 1
    'fsep': (*(*sPtr).mfoPtr)[2] = 2

    'mon': (*(*sPtr).mfoPtr)[3] = 0
    'time': (*(*sPtr).mfoPtr)[3] = 1

    'cancel': widget_control, event.top, /destroy

    'ok': begin
        (*sPtr).exitOK = 1
        widget_control, event.top, /destroy
    end
 
endcase

end



;===============================================================================
; Presents a dialog in which the user can make choices about how
; multiple input files should be dealt with.
pro fans_settings, event

widget_control, event.top, get_uvalue = sPtr
mfoPtr=(*sPtr).mfoPtr
;mfoPtr = ptr_new([1,1,1,0,0])

; build the settings dialog
tlbID = widget_base(/col,title='CONFIGURE OPTIONS',/modal,group_leader=event.top)

cb0ID = widget_base(tlbID,/col,frame=1,/align_center)

void = widget_label(cb0ID,value='Multiple input files settings')

cb1ID = widget_base(cb0ID,/row)
cb1aID = widget_base(cb1ID,/row,/align_center)
cb1bID = widget_base(cb1ID,/row,/exclusive)

cb2ID = widget_base(cb0ID,/row)
cb2aID = widget_base(cb2ID,/row,/align_center)
cb2bID = widget_base(cb2ID,/row,/exclusive)

cb3ID = widget_base(cb0ID,/row)
cb3aID = widget_base(cb3ID,/row,/align_center)
cb3bID = widget_base(cb3ID,/row,/exclusive)

cb4ID = widget_base(tlbID,/row,frame=1,/align_center)
void = widget_label(cb4ID,value='Normalize to:')
cb4aID = widget_base(cb4ID,/row,/exclusive,/align_center)

cb5ID = widget_base(tlbID,/row,/align_center,frame=1)

cb6ID = widget_base(tlbID,/row,/align_center)

void = widget_label(cb1aID,value='    Sample:')
sSumID = widget_button(cb1bID,value='sum',uname='ssum')
sapdID = widget_button(cb1bID,value='merge',uname='sapd',sensitive=0)
ssepID = widget_button(cb1bID,value='seperate',uname='ssep')
case (*mfoPtr)[0] of 
    0: widget_control, sSumID, /set_button
    1: widget_control, sapdID, /set_button
    2: widget_control, ssepID, /set_button
endcase

void = widget_label(cb2aID,value='Background:')
bSumID = widget_button(cb2bID,value='sum',uname='bsum')
bapdID = widget_button(cb2bID,value='merge',uname='bapd',sensitive=0)
bsepID = widget_button(cb2bID,value='seperate',uname='bsep')
case (*mfoPtr)[1] of 
    0: widget_control, bSumID, /set_button
    1: widget_control, bapdID, /set_button
    2: widget_control, bsepID, /set_button
endcase

void = widget_label(cb3aID,value=' Fast Bkgd:')
fSumID = widget_button(cb3bID,value='sum',uname='fsum')
fapdID = widget_button(cb3bID,value='merge',uname='fapd',sensitive=0)
fsepID = widget_button(cb3bID,value='seperate',uname='fsep')
case (*mfoPtr)[2] of 
    0: widget_control, fSumID, /set_button
    1: widget_control, fapdID, /set_button
    2: widget_control, fsepID, /set_button
endcase

normToMonID = widget_button(cb4aID,value='Monitor',uname='mon',sensitive=0)
normToTimeID = widget_button(cb4aID,value='Time',uname='time')
case (*mfoPtr)[3] of
    0: widget_control, normToMonID, /set_button
    1: widget_control, normToTimeID, /set_button
endcase 

void = widget_label(cb5ID,value='Number of active detectors:')
dlist = indgen(89)+40           ; can choose from 10 to 128
result = where(dlist eq (*sPtr).nosActDets)
nActDetID = widget_droplist(cb5ID,value=strtrim(string(dlist),2),uname='adet',uvalue=dlist)
widget_control, nActDetID, set_droplist_select=result[0] ; default is 50 detectors

okID = widget_button(cb6ID,value='OK',uname='ok')
cancelID = widget_button(cb6ID,value='CANCEL',uname='cancel')

widget_control, tlbID, /realize

tmpPtr = ptr_new({mfoPtr:ptr_new(*mfoPtr), $       ;ptr_new([*mfoPtr,0,0,50]), $
                  stype:0, $
                  exitOK:0, $
                  index:result[0] $
                 })
widget_control, tlbID, set_uvalue=tmpPtr

;store current mfoPtr settings
old_mfo = *mfoPtr

; lanch dialog and let user choose options
xmanager, 'fans_settings',tlbID

if ( (*tmpPtr).exitOK ) then begin ; ==> dialog exited with 'ok' so apply changes
    ;; note the current nos of active detectors
    (*sPtr).nosActDets = dlist[(*tmpPtr).index]

    ;; if switching from 'separate' analysis, record current indices
    if ((*tmpPtr).stype gt 0) then begin
        case (*tmpPtr).stype of
            1: (*sPtr).sampSepIndex = (*sPtr).sampIndex
            2: (*sPtr).bkgdSepIndex = (*sPtr).bkgdIndex
            3: (*sPtr).fastSepIndex = (*sPtr).fastIndex
        endcase 
    endif
    
    ;; make necessary updates to data
    (*mfoPtr) = (*(*tmpPtr).mfoPtr)
    if ( n_elements(where(*mfoPtr eq old_mfo)) ne 4 ) then begin ; ie if settings have altered
        fans_ApplySettings, sPtr, err=err, emasg=emsg
        if (err ne 0) then begin
            printerror, err, emsg
            return
        endif
    endif 
endif

ptr_free,(*tmpPtr).mfoPtr,tmpPtr                 ; no longer required

end

