;$Id: Ivq.pro,v 1.2 2002/05/20 03:41:18 jmspark Exp $
pro ivq $
	; INPUT
	,q $				; X
	,e $				; Y
	,ri $				; Func.
	,dri $				; Error
	; OUTPUT
	,qo,rio,drio $
	; INPUT (Optional)
	,eran=eran $
	, nqs = nqs $		; x dimension of Q.

	; 'white' is an old scheme to treat the data that is noexistent.
	; Surely we have to move on to use !values.f_nan or !values.d_nan.
	; 'white' is usually given the value of -1e30, a big negative value.
	, white = white

	if n_elements(eran) ne 2 then eran(0)=min(e,max=eran(1))
	if n_elements(nqs) ne 1 then nqs = n_elements( q[*,0] )
	if n_elements(white) ne 1 then white=-1e30

	; Backing up the input.
	q0 = q
	e0 = e
	ri0	= ri
	dri0 = dri

	; Make q & e 2D arrays.
	sq = size(q)
	if sq[0] eq 1 then begin
		nw	=	n_elements(e)
		oned	=	1.+fltarr(nw)
		q	=	q#oned
	endif
	ws	=	size(e)
	if ws[0] eq 1 then begin
		oned	=	1.+fltarr(n_elements(q[*,0]))
		e	=	oned#e
	endif

	lreal	=	where(ri ne white)

	; Make arrays 1D vectors.
	q	=	reform(q(lreal))
	e	=	reform(e(lreal))
	ri	=	reform(ri(lreal))
	dri	=	reform(dri(lreal))

	minq = min( q, max=maxq )

	; Generate new vectors and arrays.
	qst = ( maxq - minq ) / ( nqs - 1 ) ; Q step.

	; Qo is an equally spaced vector.
	qo = minq + findgen(nqs) * qst

	rio = fltarr(nqs) + white
	drio = fltarr(nqs) + white
	num	= fltarr(nqs)

	for i=0, nqs-1 do begin

		lis	=	where( (q ge qo(i)-qst/2. and q lt qo(i)+qst/2.),no)
		if no eq 0 then goto,skip
		lis1	=	where(e(lis) ge eran(0) and e(lis) le eran(1),no)
		if no eq 0 then goto,skip
		rio(i)	=	total(ri(lis(lis1)))/no*abs(eran(1)-eran(0))
		drio(i)	=	sqrt(total(dri(lis(lis1))^2))/no*abs(eran(1)-eran(0))

	skip:
	end

	lis	=	where(rio ne white,no)
	if no gt 0 then begin
		qo	=	qo(lis)
		rio	=	rio(lis)
		drio	=	drio(lis)
	end

	q	=	q0
	e	=	e0
	ri	=	ri0
	dri	=	dri0

end