;$Id: errbarxy.pro,v 1.2 2002/05/20 03:41:18 jmspark Exp $
;
; Plots error bar horizontally or vertically.
;
pro errbarxy,x,dx,y,dy,ymin=ymin, _extra = _extra

	; if plotting in logarithmic y-axis
	; then whenver y-dy is less then ymin (0) put y-dy=ymin

	if n_elements(ymin) eq 0 then ymin=-1e3

	npts = n_elements(y)
	xbe	= fltarr(2)
	ybe = fltarr(2)

	for i=0,npts-1 do  begin

 		;x error bar
 		if dx[i] ne 0. then begin
 			xbe(0) =	x(i)-dx(i)
 			ybe(0)	=	y(i)
 			xbe(1)	=	x(i)+dx(i)
 			ybe(1)	=	y(i)
 			oplot,xbe,ybe, _extra=_extra
 		endif

 		if n_elements(dy) gt 0 then begin
			if dy(i) ne 0. then begin
		    	xbe(0)	=	x(i)
		    	ybe(0)	=	y(i)-dy(i)
    			if ybe(0) lt ymin then ybe(0)=ymin
    			xbe(1)	=	x(i)
    			ybe(1)	=	y(i)+dy(i)
    			oplot,xbe,ybe,_extra=_extra
   			endif
 		endif

	endfor

	return

end