;$Id: ibuftoqe.pro,v 1.1 2002/04/23 14:47:01 jmspark Exp $

pro ibuftoqe,filename,d,asd=asd				$
	,a4=a4,back1=back1,ttmin=ttmin,nosens=nosens	$
	,back2=back2,ttb2=ttb2,tol=tol,monorm=monorm,xtit=xtit
;
; read i-buffer ASD file and convert A4 to (q,e)
;

if n_elements(ttmin) ne 1 then ttmin=7
if n_elements(ttb2) ne 2 then ttb2=25
; pr min for Ef=3.15meV w/o in-pile collimator
if n_elements(asd) ne 2 then asd=[7,244]
if n_elements(xtit) ne 1 then xtit='A4'

;*	read in raw data 	*
if n_elements(back1) ne 0 and n_elements(back2) ne 0 and n_elements(ttb2) ne 0$
        then begin
	readasd,filename,data,xtitle=xtit
	if n_elements(data.de(*,0)) eq 1 then a4=[data.de(*,0)]	$
		else a4=data.de(*,0)
	mon	=	data.mon

	readasd,back1,bg1,xtitle=xtit
;	print,back1
;	print,'mon=',mon
;	print,'scaling factor=',mon/bg1.mon
	bg1.asd	=	bg1.asd*mon/bg1.mon
	bg1.dasd=	bg1.dasd*mon/bg1.mon
	readasd,back2,bg2,xtitle=xtit
;	print,back2
;	print,'bk mon=',bg1.mon,bg2.mon
;	print,'scaling factor=',mon/bg2.mon
	bg2.asd	=	bg2.asd*mon/bg2.mon
	bg2.dasd=	bg2.dasd*mon/bg2.mon
	combbkgd,bg1,bg2,ttb2,bg

	if n_elements(tol) ne 1 then 	$
		tol=1e-4*(max(data.de(*,0))-min(data.de(*,0)))
	if total(bg2.asd) eq 0 then 	$
		print,'from ibuftoqe.pro: bkgd=0, something wrong?'

	subtasd,data,bg,d,tol=tol
	cutdat,d,[ttmin,200]
	if n_elements(monorm) ne 1 then monorm=d.mon
	d.asd	=	d.asd*monorm/mon
	d.dasd	=	d.dasd*monorm/mon
end else begin
	readasd,filename,d,xtitle=xtit
	if n_elements(d.de(*,0)) eq 1 then a4=[d.de(*,0)]	$
		else a4=d.de(*,0)
	mon	=	normf(d)
	cutdat,d,[ttmin,200]
	if n_elements(monorm) ne 1 then monorm=d.mon
	d.asd	=	d.asd/mon*monorm	; intensity
	d.dasd	=	d.dasd/mon*monorm	; error
end

pg002 = 1.87325

if file_which('calfil.dat') eq '' then begin
	calfil_file = 'calfil.dat'
endif else begin
	calfil_file = file_which('calfil.dat')
endelse
openr,lun, calfil_file,/get_lun
readf,lun,npix
ef	=	fltarr(npix)
sens	=	fltarr(npix)
readf,lun,ef
readf,lun,sens
free_lun,lun

ei	=	2.0717*(pg002/2./sin(d.de(0,where(d.tde eq 'A1'))*!dtor))^2

dtt	=	asin(pg002/2./sqrt(ef/2.0717))		$
	       		-asin(pg002/2./sqrt(ef(127)/2.0717))
oneset	=	1+fltarr(n_elements(a4))
onepix	=	1+fltarr(npix)
d.q	=	sqrt( (ei+oneset#ef-2*oneset#sqrt(ei*ef)	$
			*Cos(a4#onepix*!dtor+oneset#dtt))/2.0717)
d.hw	=	ei-oneset#ef

;**********************************************
;* perform sensitivity correction if required *
;**********************************************
if not keyword_set(nosens) then begin
	divmat	=	oneset#((1.e-8+sens)*sqrt(ef/ef(127)))
    	d.asd	= 	d.asd/divmat
    	d.dasd 	= 	d.dasd/divmat
end

cutdat,d,asd=asd

end

