;$Id: trifenestra_beautify_string.pro,v 1.2 2002/04/26 22:41:53 jmspark Exp $
function trifenestra_beautify_string_core, string, match_str, replacement

	if not ( strmatch( string, '*' + match_str + '*' ) )[0] then return, string
	array = strsplit( string[0], match_str, /extract )
	if n_elements( array ) eq 2 then return, strjoin( array, replacement )
	if n_elements( array ) eq 0 then return, replacement
	case (strpos( string, match_str ))[0] of
		0: return, replacement + array
		else: return, array + replacement
	endcase

end


function trifenestra_beautify_string, string

	if n_elements( string ) eq 0 then return, ''

	result = trifenestra_beautify_string_core( string $
		, 'inv_A', labels(/inv_a) )
	result = trifenestra_beautify_string_core( result $
		, 'Angstrom', labels(/angstrom) )
	result = trifenestra_beautify_string_core( result $
		, 'hw', labels(/hw) )

	if ( string eq 'qudan' )[0] then !trifenestra.internal = 1B

	return, result

end