; $Id: ppopup.pro,v 1.3 2002/03/28 01:41:34 jmspark Exp $
PRO print_ps, filename=filen, encapsulated=encap, noplot=noplot, info=info, davePtr = davePtr
;+
;	NAME: print_ps
;	DESCRIPTION: Prints a tasxp plot on a PostScript printer
;		INTERNAL tasxp procedure
;	MODIFICATION HISTORY:
;		Paul Schleger, Riso National Lab, Nov 1993
;-
COMMON data,xax,yax,fit,symboln,dindex,d,xmin,xmax,ymin,ymax,pcomm
COMMON fitinfo_com, fitstuff
COMMON com_minchoice, minchoice, minpath

     IF NOT keyword_set(filen) THEN filen='tasxp.ps'
     psinit, FILE = filen, /QUIET
     IF keyword_set(encapsulated) THEN device, /ENCAPSULATED
     device, /HELVETICA
     IF keyword_set(info) THEN BEGIN
     	psave=!P.REGION
     	!P.REGION = [0.2,0.4,0.8,1.0]
     	lasty = 0.35	;normalized y axis coordinates of where there is still room
     END ELSE lasty=-0.1
     taspl,d,xax,yax,nsym=symboln,xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax, davePtr=davePtr
     IF (fit eq 'true') THEN $
     	fitov,d,xax,xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,/hardcopy,lasty=lasty
     ;Print out tasinfo as well
     IF keyword_set(info) THEN BEGIN
     	;Use the typwriter font to avoid proportional spacing
     		str = tasinfo(d,/ongraph,font=11)
     		IF (minchoice NE 'SFit') AND (fit EQ 'true') THEN $
			str = str+fitinfo(fitstuff,/ongraph,font=11)
     		xyouts, 0.1, lasty, str, /NORMAL, charsize=0.7
     		!P.REGION = psave
     END
     psterm, noplot=noplot
     set_plot, 'x'
END

pro ppopup_event,ev
;Event Handler for ppopup, below
COMMON data,xax,yax,fit,symboln,dindex,d,xmin,xmax,ymin,ymax,pcomm
COMMON COMMON_fname, name, first_time
COMMON com_stuffy, info
widget_control, name, GET_VALUE=filen
filen=filen(0)
CASE ev.value of
  'Print on HP': BEGIN
     widget_control,/hour
     print_ps, info=info
     widget_control,ev.top,/destroy
     END
  'Encapsulated Postscript file':BEGIN
     widget_control,/hour
     IF (strlen(filen) EQ 0) THEN filen=0 ELSE filen=filen+'.eps'
     print_ps, /NOPLOT, /ENCAPSULATED, filename=filen, info=info
     widget_control,ev.top,/destroy
     END
  'Postscript file':BEGIN
     widget_control,/hour
     IF (strlen(filen) EQ 0) THEN $
     	filen=0 ELSE $
     	filen=filen+'.ps'
     print_ps, /NOPLOT, filename=filen, info=info
     END
  'CGM file':BEGIN
     widget_control,/hour
     set_plot,'cgm'
     loadct,0
     IF (strlen(filen) EQ 0) THEN filen=0 ELSE filen=filen+'.cgm'
     device,filename=filen,/binary
     taspl,d,xax,yax,nsym=symboln,xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax, davePtr=davePtr
     IF (fit eq 'true') THEN fitov,d,xax,xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,/hardcopy
     device,/close
     set_plot,'X'
     widget_control,ev.top,/destroy
     END
  'Yes': info=1
  'No': info=0
  'Cancel':widget_control,ev.top,/destroy
  ENDCASE
END

pro ppopup
;+
;	NAME: ppopup
;	DESCRIPTION: Pops up a window in tasxp to make a hardcopy of a plot
;		INTERNAL tasxp PROCEDURE
;	MODIFICATION HISTORY:
;		Thom Mason, Riso National Lab., 1993
;	Nov 1993 Paul Schleger, ditto
;		changed it so that we use compound widget function calls
;		Also added an input field to allow printing to a seperate
;		file
;-
COMMON data,xax,yax,fit,symboln,dindex,d,xmin,xmax,ymin,ymax,pcomm
COMMON COMMON_fname, name, first_time
COMMON com_stuffy, info
base=widget_base(title='Hardcopy',xsize=300,/column)
things=['Print on HP','Encapsulated Postscript file','Postscript file',$
	'CGM file','Cancel']
buttons=cw_bgroup(base,things,/RETURN_NAME,/COLUMN)
button6=cw_bgroup(base,LABEL_LEFT='Print Extra Info?',['Yes','No'],$
/EXCLUSIVE,/RETURN_NAME,ROW=1,SET_VALUE=0)
info=1
IF (first_time NE 0) THEN BEGIN
	IF (strlen(d.text(0)) LE 10) THEN fname=d.text(0) ELSE fname='tasxp'
	first_time=0
END
name=cw_field(base,uvalue='File',/STRING,/COLUMN,TITLE='File Name (no extension):',$
	value=fname)
widget_control,base,/realize
xmanager,'ppopup',base
END



